/***
 * GASP: a gaming services platform for mobile multiplayer games.
 * MooDS: a communication protocol used in GASP
 *
 * Copyright (C) 2004,2005 CNAM/INT - 2006 CNAM/INT/Filao
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Romain Pellerin, Chanty Lim
 */
package org.mega.moods.generator;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;


/**
 * MooDS Generator v2.0
 * @author Romain PELLERIN
 */
public class ClassMaker {

    private static Hashtable classFileObjects = new Hashtable();
    private static Hashtable classesToMake = new Hashtable();
    
    // languages:
    // 0: Java
    // 1: Flash
    public static final int JAVA = 0;
    public static final int FLASH = 1;
    
    
    public static void init(){
    	classFileObjects = new Hashtable();
    	classesToMake = new Hashtable();
    }
    
    public static void createClassEntry(int language, String linkClass, String classname, String[] classParts, boolean isACommonClass) throws IOException{
    	// store link between array and class name
    	classesToMake.put(linkClass,classParts);
    	
    	// create the file to make
    	System.out.println("ClassMaker: create file "+Generator.getPath(language,isACommonClass)+classname+"."+LanguageTranslator.getLanguageFileExtension(language));
    	File classFile = new File(Generator.getPath(language,isACommonClass)+classname+"."+LanguageTranslator.getLanguageFileExtension(language));
    	classFile.createNewFile();
    	
    	// store the file manager for this class
    	classFileObjects.put(linkClass,classFile);
    	
    	System.out.println("ClassMaker: class entry "+linkClass+" for classname "+classname+" at path "+classFile.getPath());
    }
        
    public static void flushClass(String className) throws IOException{
    	System.out.println("Flush "+ className+" ...");
    	
    	// open file
    	File file = (File) classFileObjects.get(className);
		FileWriter writer =  new FileWriter(file);
    	
    	String[] strings = (String[]) classesToMake.get(className);
    	String stringToFlush = "";
    	
    	for(int i=0; i<strings.length; i++)
    		stringToFlush += strings[i];
    
    	writer.flush();
       	writer.write(stringToFlush);
        writer.close();
        
        System.out.println(file.getName()+ " flushed");
    }
    
    public static void flushClasses() throws IOException{
    	 System.out.println(" ");
    	 System.out.println("> Flush classes ");
    	 Enumeration e = classFileObjects.keys();
    	 while (e.hasMoreElements()){
    		 flushClass((String) e.nextElement());
         }
    	 System.out.println("classes made");
    }
}
